/* Copyright 2001-2002 TransGaming Technologies, Inc. */
#ifndef _D3DGL_PRIVATE_H_INCLUDED
#define _D3DGL_PRIVATE_H_INCLUDED

#include <wine_gl.h>

#include "wine/d3dhalp.h"
#include "wine/d3dhalgl.h"

/* see http://oss.sgi.com/projects/ogl-sample/registry/ */
#define DD_GL_EXTENSION_LIST \
    DD_GL_EXT(ARB_imaging), \
    DD_GL_EXT(ARB_multitexture), \
    DD_GL_EXT(ARB_transpose_matrix), \
    DD_GL_EXT(ARB_multisample), /* TODO */ \
    DD_GL_EXT(ARB_texture_env_add), \
    DD_GL_EXT(ARB_texture_cube_map), \
    DD_GL_EXT(ARB_texture_compression), \
    DD_GL_EXT(ARB_texture_border_clamp), \
    DD_GL_EXT(ARB_point_parameters), /* TODO? */ \
    DD_GL_EXT(ARB_vertex_blend), \
    DD_GL_EXT(ARB_matrix_palette), /* TODO */ \
    DD_GL_EXT(ARB_texture_env_combine), \
    DD_GL_EXT(ARB_texture_env_crossbar), /* TODO? (use for D3DTOP_PREMODULATE) */ \
    DD_GL_EXT(ARB_texture_env_dot3), \
    DD_GL_EXT(ARB_texture_mirrored_repeat), \
    DD_GL_EXT(ARB_depth_texture), \
    DD_GL_EXT(ARB_shadow), \
    DD_GL_EXT(ARB_shadow_ambient), \
    DD_GL_EXT(ARB_window_pos), \
    DD_GL_EXT(ARB_vertex_program), /* TODO */ \
    DD_GL_EXT(ARB_fragment_program), /* TODO */ \
    /* out of ARB extensions... what EXT extensions might also be useful? */ \
    DD_GL_EXT(EXT_point_parameters),		/* 54 - TODO */ \
    DD_GL_EXT(EXT_clip_volume_hint),		/* 79 */ \
    DD_GL_EXT(EXT_compiled_vertex_array),	/* 97 - maybe? */ \
    DD_GL_EXT(EXT_secondary_color),		/* 145 */ \
    DD_GL_EXT(EXT_fog_coord),			/* 149 - TODO */ \
    DD_GL_EXT(EXT_texture_env_combine),		/* 158 */ \
    DD_GL_EXT(EXT_blend_func_separate),		/* 173 - do we need this? */ \
    DD_GL_EXT(EXT_stencil_wrap),		/* 176 */ \
    DD_GL_EXT(EXT_texture_env_add),		/* 185 */ \
    DD_GL_EXT(EXT_texture_lod_bias),		/* 186 */ \
    DD_GL_EXT(EXT_texture_filter_anisotropic),	/* 187 */ \
    DD_GL_EXT(EXT_vertex_weighting),		/* 188 */ \
    DD_GL_EXT(EXT_texture_compression_s3tc),	/* 198 */ \
    DD_GL_EXT(EXT_texture_env_dot3),		/* 220 */ \
    DD_GL_EXT(EXT_vertex_shader),		/* 248 - TODO? */ \
    DD_GL_EXT(EXT_shadow_funcs),		/* 267 - ? */ \
    /* out of EXT extensions... */ \
    DD_GL_EXT(NV_texgen_reflection),		/* 179 */ \
    DD_GL_EXT(NV_vertex_array_range),		/* 190 */ \
    DD_GL_EXT(NV_register_combiners),		/* 191 - TODO */ \
    DD_GL_EXT(NV_fog_distance),			/* 192 - TODO */ \
    DD_GL_EXT(NV_blend_square),			/* 194 */ \
    DD_GL_EXT(NV_texture_env_combine4),		/* 195 - TODO */ \
    DD_GL_EXT(ATI_texture_mirror_once),		/* 221 */ \
    DD_GL_EXT(NV_fence),			/* 222 */ \
    DD_GL_EXT(IBM_texture_mirrored_repeat),	/* 224 */ \
    DD_GL_EXT(NV_evaluators),			/* 225 - TODO */ \
    DD_GL_EXT(NV_register_combiners2),		/* 227 */ \
    DD_GL_EXT(NV_texture_shader),		/* 230 - TODO */ \
    DD_GL_EXT(NV_texture_shader2),		/* 231 - TODO */ \
    DD_GL_EXT(NV_vertex_array_range2),		/* 232 */ \
    DD_GL_EXT(NV_vertex_program),		/* 233 */ \
    DD_GL_EXT(ATI_envmap_bumpmap),		/* 244 - TODO */ \
    DD_GL_EXT(ATI_fragment_shader),		/* 245 - TODO? */ \
    DD_GL_EXT(ATI_pn_triangles),		/* 246 - TODO */ \
    DD_GL_EXT(ATI_vertex_array_object),		/* 247 - TODO? */ \
    DD_GL_EXT(ATI_vertex_streams),		/* 249 - TODO */ \
    DD_GL_EXT(ATI_element_array),		/* 256 - TODO */ \
    DD_GL_EXT(NV_multisample_filter_hint),	/* 259 - TODO */ \
    DD_GL_EXT(NV_depth_clamp),			/* 260 - ? */ \
    DD_GL_EXT(NV_point_sprite),			/* 262 - TODO */ \
    DD_GL_EXT(NV_texture_shader3),		/* 265 - TODO */ \
    DD_GL_EXT(NV_vertex_program1_1),		/* 266 */ \
    DD_GL_EXT(ATI_text_fragment_shader),	/* 269 - TODO */ \
    DD_GL_EXT(S3_s3tc),				/* 276 - TODO? */ \
    DD_GL_EXT(ATI_texture_env_combine3),	/* 279 - TODO */ \
    DD_GL_EXT(ATI_texture_float),		/* 280 - TODO */ \
    DD_GL_EXT(NV_float_buffer),			/* 281 - TODO */ \
    DD_GL_EXT(NV_fragment_program),		/* 282 - TODO */ \
    DD_GL_EXT(NV_half_float),			/* 283 - TODO */ \
    DD_GL_EXT(NV_vertex_program2)		/* 287 - TODO */

#define DD_GL_EXT(x) x
typedef enum {
    DD_GL_EXTENSION_LIST,
    DD_GL_EXTENSION_COUNT
} DD_GL_ext;
#undef DD_GL_EXT

#define DD_GL_PROC_LIST \
    DD_GL_PROC(PFNGLACTIVETEXTUREARBPROC,glActiveTextureARB) \
    DD_GL_PROC(PFNGLCLIENTACTIVETEXTUREARBPROC,glClientActiveTextureARB) \
    DD_GL_PROC(PFNGLMULTITEXCOORD2FARBPROC,glMultiTexCoord2fARB) \
    DD_GL_PROC(PFNGLSECONDARYCOLOR3UBEXTPROC,glSecondaryColor3ubEXT) \
    DD_GL_PROC(PFNGLSECONDARYCOLORPOINTEREXTPROC,glSecondaryColorPointerEXT) \
    DD_GL_PROC(PFNGLCOMPRESSEDTEXIMAGE2DARBPROC,glCompressedTexImage2DARB) \
    DD_GL_PROC(PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC,glCompressedTexSubImage2DARB) \
    DD_GL_PROC(PFNGLWEIGHTPOINTERARBPROC,glWeightPointerARB) \
    DD_GL_PROC(PFNGLVERTEXBLENDARBPROC,glVertexBlendARB) \
    DD_GL_PROC(PFNGLVERTEXWEIGHTPOINTEREXTPROC,glVertexWeightPointerEXT) \
    DD_GL_PROC(PFNGLGENPROGRAMSNVPROC,glGenProgramsNV) \
    DD_GL_PROC(PFNGLLOADPROGRAMNVPROC,glLoadProgramNV) \
    DD_GL_PROC(PFNGLBINDPROGRAMNVPROC,glBindProgramNV) \
    DD_GL_PROC(PFNGLDELETEPROGRAMSNVPROC,glDeleteProgramsNV) \
    DD_GL_PROC(PFNGLPROGRAMPARAMETER4FNVPROC, glProgramParameter4fNV) \
    DD_GL_PROC(PFNGLPROGRAMPARAMETER4FVNVPROC, glProgramParameter4fvNV) \
    DD_GL_PROC(PFNGLPROGRAMPARAMETERS4FVNVPROC, glProgramParameters4fvNV) \
    DD_GL_PROC(PFNGLGETPROGRAMPARAMETERFVNVPROC, glGetProgramParameterfvNV) \
    DD_GL_PROC(PFNGLGETVERTEXATTRIBPOINTERVNVPROC, glGetVertexAttribPointervNV) \
    DD_GL_PROC(PFNGLVERTEXATTRIBPOINTERNVPROC, glVertexAttribPointerNV)


#define DD_GL_PROC(x,y) x y;
typedef struct _DD_GL_data {
    char gl_ext[DD_GL_EXTENSION_COUNT];
    DD_GL_PROC_LIST
    D3DCAPS8 caps8;
} DD_GL_data;
#undef DD_GL_PROC

struct GL_D3D_saved_cmd
{
    struct GL_D3D_saved_cmd *next;
    D3DHAL_DP2COMMAND cmd;
    LPVOID data1, data2;
};

struct GL_D3D_state_block
{
    struct GL_D3D_saved_cmd *cmds;
    unsigned int list;
};

typedef struct
{
    struct _DD_GL_data *gl_data;
    LPDDRAWI_DIRECTDRAW_LCL dd_lcl;
    LPDDRAWI_DIRECTDRAW_GBL dd_gbl;
    LPD3DHAL_D3DEXTENDEDCAPS lpCaps;
    LPD3D_P d3dp;
    LPVOID color_array;
    DWORD color_array_size;
    LPVOID vertex_array;
    DWORD vertex_array_size;
    DWORD glFlags;
    DWORD dp2_dwFlags;
    DWORD dp2_dwVertexType;
    LPVOID dp2_lpVertices;
    DWORD dp2_dwVertexOffset;
    DWORD dp2_dwVertexLength;
    LPDDRAWI_DDRAWSURFACE_LCL dp2_VertexBuffer;
    D3DDRAWPRIMITIVESTRIDEDDATA sd;
    GLDRAWPRIMITIVESTRIDEDDATA stride;
    VertexShader *current_vs;
    struct GL_D3D_saved_cmd *cmds;
    DWORD lights;
    struct GL_D3D_state_block *block;
    DWORD material_flags;
    DWORD current_color_material;
    DWORD texture_flags;
    GLfloat texture_factor[4];
    GLenum texture_target[8];
    BOOL texture_used[8];
    GLuint dummy_texture;
    int d3d_version;
    struct GL_D3D_DriverCallbacks callbacks;
    LPDDRAWI_DDRAWPALETTE_GBL gbl_pal;
    BOOL isLightingEnabled;
    BOOL isVertexProgramEnabled;
    void *pVertexArray;
    DWORD sVertexArray;
    void *pNormalArray;
    DWORD sNormalArray;
    void *pColorArray;
    DWORD sColorArray;
    void *pSecondaryColorArray;
    DWORD sSecondaryColorArray;
    void *pTexCoordArray[8];
    DWORD sTexCoordArray[8];
} GL_D3D_priv;

#define GLF_NEW_TRANSFORM		0x0002
#define GLF_NEW_VIEW			0x0004
#define GLF_NEW_TNL_MODE		0x0008
#define GLF_NEW_LIGHTING		0x0010 /* lighting & material renderstates */
#define GLF_NEW_TEXCOORD_TRANSFORM	0x0020
#define GLF_USE_VERTEX_ARRAYS		0x0040
#define GLF_STRIDED_DATA		0x0080
#define GLF_VERTEX_BUFFER		0x0100
#define GLF_VERTEX_DECLARATION		0x0200
#define GLF_VERTEX_PROGRAM		0x0400

/* values for material_flags */
#define GLMF_DO_DIFFUSE		0x001
#define GLMF_DO_SPECULAR	0x002
#define GLMF_DO_AMBIENT		0x004
#define GLMF_DO_EMISSIVE	0x008
#define GLMF_DIFFUSE_DIRTY	0x010
#define GLMF_SPECULAR_DIRTY	0x020
#define GLMF_AMBIENT_DIRTY	0x040
#define GLMF_EMISSIVE_DIRTY	0x080
#define GLMF_SHININESS_DIRTY	0x100
#define GLMF_COLOR_MATERIAL	0x200

#define GLMF_ALL_MATERIAL_DIRTY \
(GLMF_DIFFUSE_DIRTY|GLMF_SPECULAR_DIRTY|GLMF_AMBIENT_DIRTY|GLMF_EMISSIVE_DIRTY\
|GLMF_SHININESS_DIRTY)

/* values for texture_flags */
#define GLTF_DEFAULT_TEXCOORD_TRANSFORM	0x01


#define GL_FVF_NEW_TNL_BITS (D3DFVF_POSITION_MASK|D3DFVF_NORMAL)
#define GL_CHECK_NEW_TNL(x,y) (((x) ^ (y)) & GL_FVF_NEW_TNL_BITS)

#define GLD(priv) ((priv)->gl_data)
#define HAVE_GL_EXT(priv,ext) (GLD(priv)->gl_ext[ext])

#define CHECK_GL_ERROR(x) do { GLenum err; err = glGetError(); if (err) ERR("glGetError returns %08x for %s\n", err, x); } while (0)

#define D3DTSS_TCI_MASK 0xFFFF0000U
#define D3DTTFF_COUNT_MASK 0xFFU

/* light.c */
HRESULT D3D_GL_create_light(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_set_light(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
void GL_LoadLightPositions(GL_D3D_priv* priv, BOOL force);

/* prim.c */
HRESULT D3D_GL_draw(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_clear(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);

/* state.c */
HRESULT D3D_GL_sync_render_state(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_async_render_state(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_viewport_info(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_z_range(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_set_material(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_set_transform(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_set_clip_plane(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);

/* texture.c */
void GL_LoadTextureFactor(GL_D3D_priv* priv, GLfloat col[4]);
HRESULT D3D_GL_texture_stage_state(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_set_palette(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_update_palette(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_texblt(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT GL_Direct3DDevice_validate_device(GL_D3D_priv* priv, LPDWORD lpdwPasses);

/* fixedfunc.c */
typedef DWORD (*GL_IndexFunc)(DWORD idx, LPVOID p);
void GL_draw_unlit_vertices(GL_D3D_priv* priv, GLenum gltype, DWORD vt,
			    DWORD start, DWORD count, GL_IndexFunc index,
			    LPVOID index_data);
DWORD D3D_GL_setup_fixed(GL_D3D_priv* priv, LPVOID data1, 
                         const WORD* indices, GLenum pt, 
			 DWORD dwCount, BOOL indexed);
void D3D_GL_finish_fixed(GL_D3D_priv* priv);

/* vprogram.c */
HRESULT D3D_GL_create_vertex_shader(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_set_vertex_shader(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_set_vertex_shader_const(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
HRESULT D3D_GL_delete_vertex_shader(GL_D3D_priv* priv, LPD3DHAL_DP2COMMAND cmd, LPVOID data1, LPVOID data2);
void D3D_GL_setup_programmable(GL_D3D_priv* priv, LPVOID data1,
                               const WORD* indices, GLenum pt, 
                               DWORD dwCount, BOOL indexed);
void D3D_GL_finish_programmable(GL_D3D_priv* priv);

#endif
