/* This is the header file for the service providers
 * This is MY OWN (ie. made up) interface for IDirectPlay8ThreadPool.
 * Microsoft wont give out docs for it. sigh.
 * It is very much a work in progress!
 */

#ifndef _WINE_DP8THREADPOOL_H__
#define _WINE_DP8THREADPOOL_H__

#include "ole2.h"

#ifdef __cplusplus
extern "C" {
#endif

#include "dplay8.h"

/* CLSID for DirectPlay8ThreadPool */
/* {FC47060E-6153-4B34-B975-8E4121EB7F3C} */
DEFINE_GUID(CLSID_DirectPlay8ThreadPool,
0xfc47060e, 0x6153, 0x4b34, 0xb9, 0x75, 0x8e, 0x41, 0x21, 0xeb, 0x7f, 0x3c);

/* IID for DirectPlay8ThreadPool */
/* {12F40839-E7A3-499B-AB45-9E433D8B3196} */
DEFINE_GUID(IID_IDirectPlay8ThreadPool,
0x12f40839, 0xe7a3, 0x399b, 0xab, 0x45, 0x9e, 0x43, 0x3d, 0x8b, 0x31, 0x96);

/* interface pointers */

typedef struct IDirectPlay8ThreadPool IDirectPlay8ThreadPool, *PDIRECTPLAY8THREADPOOL;

/* external types */

/* callback functions */
typedef void (*tpJobFunc)(void *, void *);

/* non structure/message datatypes */

/* message identifiers */

/* constants */

/* Flags */

/* non message structures */

typedef struct _DPTP_timerInfo
{
    tpJobFunc func; /* adds this function to the threadpool queue when timer goes off */
    void *arg1, *arg2;
    DWORD dwTimerWait; /* milliseconds */
    void *dpData; /* data used by the implementation, so it can be removed */
} DPTP_timerInfo;

/* message callback structures */

/* functions */

/******** Interfaces *******/

/* IDirectPlay8ThreadPool */
#define ICOM_INTERFACE IDirectPlay8ThreadPool
#define IDirectPlay8ThreadPool_METHODS \
    ICOM_METHOD2(HRESULT,Initialize,               DWORD, dwMaxThreads, DWORD, dwFlags) \
    ICOM_METHOD1(HRESULT,GetMaxThreads,            DWORD*, pdwMaxThreads) \
    ICOM_METHOD1(HRESULT,SetMaxThreads,            DWORD, dwMaxThreads) \
    ICOM_METHOD3(HRESULT,QueueWorkItem,            tpJobFunc, pjfCallback, void *, arg1, void*, arg2) \
    ICOM_METHOD1(HRESULT,QueueTimerItem,           DPTP_timerInfo *, newTimerInfo) \
    ICOM_METHOD1(HRESULT,DeleteTimerItem,          void *, pdpData) \
    ICOM_METHOD1(HRESULT,ResetTimerItem,           void *, pdpData)
#define IDirectPlay8ThreadPool_IMETHODS \
    IUnknown_IMETHODS \
    IDirectPlay8ThreadPool_METHODS
ICOM_DEFINE(IDirectPlay8ThreadPool, IUnknown)
#undef ICOM_INTERFACE

  /* IUnknown methods */
#define IDirectPlay8ThreadPool_QueryInterface(p,a,b)           ICOM_CALL2(QueryInterface,p,a,b)
#define IDirectPlay8ThreadPool_AddRef(p)                       ICOM_CALL (AddRef,p)
#define IDirectPlay8ThreadPool_Release(p)                      ICOM_CALL (Release,p)
  /* IDirectPlay8ThreadPool methods */
#define IDirectPlay8ThreadPool_Initialize(p,a,b)               ICOM_CALL2(Initialize,p,a,b)
#define IDirectPlay8ThreadPool_GetMaxThreads(p,a)              ICOM_CALL1(GetMaxThreads,p,a)
#define IDirectPlay8ThreadPool_SendToAddress(p,a)              ICOM_CALL4(SetMaxThreads,p,a)
#define IDirectPlay8ThreadPool_QueueWorkItem(p,a,b,c)          ICOM_CALL3(QueueWorkItem,p,a,b,c)
#define IDirectPlay8ThreadPool_QueueTimerItem(p,a)             ICOM_CALL1(QueueTimerItem,p,a)
#define IDirectPlay8ThreadPool_DeleteTimerItem(p,a)            ICOM_CALL1(DeleteTimerItem,p,a)
#define IDirectPlay8ThreadPool_ResetTimerItem(p,a)             ICOM_CALL1(ResetTimerItem,p,a)

#ifdef __cplusplus
}
#endif

#endif /* _WINE_DP8THREADPOOL_H__ */
