/*
 * joystick driver
 */

typedef struct _WINE_JOYSTICK_DRV WINE_JOYSTICK_DRV;

typedef struct _WINE_JOYSTICK {
  WINE_JOYSTICK_DRV *drv;
  char devname[32];
  int joyIntf;
  int devIntf;
  int detected, in_use;
  JOYCAPSA caps;
  DIDEVCAPS dicaps;
  GUID guidInstance;
  void *internal;
} WINE_JOYSTICK;

struct _WINE_JOYSTICK_DRV {
  void (*DevName)(WINE_JOYSTICK *joy);
  LONG (*GetDevCaps)(WINE_JOYSTICK *joy);
  LONG (*GetPosEx)(WINE_JOYSTICK *joy, LPJOYINFOEX lpInfo);
  HRESULT (*GetDIInfo)(WINE_JOYSTICK *joy, DWORD dwVersion, LPDIDEVCAPS lpCaps, LPDIDEVICEINSTANCEA lpInfo);
  HRESULT (*OpenDIDev)(WINE_JOYSTICK *joy, DWORD dwVersion);
  HRESULT (*CloseDIDev)(WINE_JOYSTICK *joy);
  HRESULT (*GetDIDataFormat)(WINE_JOYSTICK *joy, LPDIDATAFORMAT *pdf);
  HRESULT (*GetDIData)(WINE_JOYSTICK *joy, BOOL req, DWORD *dwObj, DWORD *dwData, DWORD *dwTimeStamp);
};

DWORD JSTCK_calc_pov4(int x, int y);
DWORD JSTCK_calc_povcts(int x, int y);
