#ifndef WINE_D3DHALGL_H_INCLUDED
#define WINE_D3DHALGL_H_INCLUDED

#include "windef.h"
#include "ddrawi.h"
#include "d3dtypes.h"

#define D3DFVF_GLCOLORORDER 0x4000 /* colours reordered to RGBA */
#define D3DFVF_GLW 0x8000 /* RHW converted to W */

typedef struct
{
    D3DDP_PTRSTRIDE position;
    D3DDP_PTRSTRIDE normal;
    D3DDP_PTRSTRIDE color[2];
    D3DDP_PTRSTRIDE textureCoords[D3DDP_MAXTEXCOORD];

    D3DDP_PTRSTRIDE blend_weights[4];
    D3DDP_PTRSTRIDE matrix_indices;
    D3DDP_PTRSTRIDE fog_coordinate;
} GLDRAWPRIMITIVESTRIDEDDATA, *LPGLDRAWPRIMITIVESTRIDEDDATA;

struct GL_D3D_DriverCallbacks
{
    DWORD dwSize;
    DWORD (*D3dVbGetConvertedFVF)(LPDDRAWI_DDRAWSURFACE_LCL vb);
    void (*D3dVbPreRender)(LPDDRAWI_DDRAWSURFACE_LCL vb,
			   LPGLDRAWPRIMITIVESTRIDEDDATA data,
			   BOOL convert,
			   DWORD vstart, DWORD vcount,
			   const WORD* indices, DWORD nindices,
			   DWORD indexbase);
    void (*D3dVbPostRender)(LPDDRAWI_DDRAWSURFACE_LCL vb);
};

DEFINE_GUID( GUID_WineGLD3DCallbacks, 0xC1E3F5C6, 0xEC82, 0x4B53, 0x94, 0xCA,
	     0xAE, 0x4F, 0x08, 0xE0, 0x46, 0x7C );

#endif
